View Issue Details

IDProjectCategoryView StatusLast Update
0001662Far ManagerMacropublic2013-06-03 16:37
ReporterRaistlinAssigned Toshmuel 
PrioritynormalSeverityminorReproducibilitysometimes
Status closedResolutionfixed 
Platformx86OSWindowsOS VersionXP SP3
Product Version2.0 
Target VersionFixed in Version3.0 
Summary0001662: Неадекватное поведение макросов с mmode()
DescriptionСоздаем в папке подпапку Folder. Затем выполняем такую команду:
for /l %A in (1,1,3000) do @copy nul File%A
После этого выделяем Folder и File1 и выполняем макрос:
macro:post mmode(1,2) $Rep (APanel.SelCount) panel.setposidx(0,1,1) print("echo " + APanel.Current) Enter panel.select(0,0,1) $End
4 возможных результата:
1. "echo Folder" + мы в папке Folder
2. "echo Folder" + мы в исходной папке с одним выделенным файлом
3. "echo Folder" + мы в исходной папке с двумя выделенными файлами
4. "echo Folder" + "echo File1" + мы в исходной папке без выделенных файлов
Все зависит от скорости перечитывания панели. Например, если создать не 3000, а 10 000 пустых файлов, то гарантированно получим вариант 3. На сетевом диске достаточно 30 файлов - тогда будет или (1), или (2). На сетевом диске, который сделан из папки в DFS-пространстве имен, достаточно и 10 файлов.
Баг слегка неустойчив - иногда может и по варианту (4) отработать. Но чем больше файлов, тем меньше вероятность.
TagsNo tags attached.
Build3431

Activities

vskirdin

2011-10-12 12:31

administrator   bugnote:0007865

Какие-то странности.
Все время (локаль, сеть) выводятся оба эха и снимается выделение (никуда не заходим)
Пробовал на Far 3 (в тройке проверь)

Raistlin

2011-10-18 22:39

reporter   bugnote:0007904

Повторяется и на Far3, только количество файлов должно быть бОльшим - при 100 000 файлов стабильно получаем вариант 1.

shmuel

2013-05-26 19:56

developer   bugnote:0011032

macro:post mmode(1,2) for k=1,APanel.SelCount do Panel.SetPosIdx(0,1,1) print("echo " .. APanel.Current) Keys"Enter" Panel.Select(0,0,1) end

У меня на Far 3 build 3424 (100 тыс. файлов в папке) стабильно отрабатывает по 4-му варианту. Просьба проверить.

shmuel

2013-05-28 23:54

developer   bugnote:0011040

3431.

shmuel

2013-05-29 03:09

developer   bugnote:0011044

После увеличения количества файлов в папке до 150 тыс. ошибка стала воспроизводиться в билдах до 3431. Начиная от 3431, должно быть всё нормально.

Raistlin

2013-06-03 02:12

reporter   bugnote:0011068

На 200 000 файлах - OK.

shmuel

2013-06-03 16:33

developer   bugnote:0011082

Если с вашей точки зрения проблемы больше нет, переводите в "resolved".
Если есть, сообщайте.

Issue History

Date Modified Username Field Change
2011-01-16 00:56 Raistlin New Issue
2011-10-12 12:31 vskirdin Note Added: 0007865
2011-10-18 22:39 Raistlin Note Added: 0007904
2013-05-26 19:56 shmuel Note Added: 0011032
2013-05-28 23:54 shmuel Note Added: 0011040
2013-05-28 23:54 shmuel Assigned To => shmuel
2013-05-28 23:54 shmuel Status new => feedback
2013-05-29 03:09 shmuel Note Added: 0011044
2013-06-03 02:12 Raistlin Note Added: 0011068
2013-06-03 02:12 Raistlin Status feedback => assigned
2013-06-03 16:33 shmuel Note Added: 0011082
2013-06-03 16:33 shmuel Status assigned => feedback
2013-06-03 16:35 Raistlin Status feedback => resolved
2013-06-03 16:37 shmuel Build => 3431
2013-06-03 16:37 shmuel Status resolved => closed
2013-06-03 16:37 shmuel Resolution open => fixed
2013-06-03 16:37 shmuel Fixed in Version => 3.0